unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms, Dialogs,
  WndSub32, Buttons, Controls, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Choose: TRadioGroup;
    SS: TButton;
    MsgLB: TListBox;
    Button3: TButton;
    before: TRadioButton;
    after: TRadioButton;
    Label2: TLabel;
    Subc1: TSubclass32;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure SSClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ChooseClick(Sender: TObject);
    procedure beforeClick(Sender: TObject);
    procedure afterClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    {$IFDEF VER100}    //if D3
    procedure Subc1MsgReceived(const Wnd: Integer; var Msg: Cardinal;
      var wParam, lParam: Integer; const ProcessId: Integer; rmFlag: TWhen;
      var return: Integer; var CallDefWndproc: Boolean);
    {$ENDIF}
    {$IFDEF VER90}   //if D2
    procedure Subc1MsgReceived(const Wnd: Integer; var Msg: Cardinal;
      var wParam, lParam: Longint; const ProcessId: Integer; rmFlag: TWhen;
      var return: Longint; var CallDefWndproc: Boolean);
    {$ENDIF}
    {$IFDEF VER120}   //if D4
    procedure Subc1MsgReceived(const Wnd: HWND; var Msg: Cardinal;
       var wParam, lParam: Integer; const ProcessId: Cardinal; rmFlag: TWhen;
       var return: Integer; var CallDefWndproc: Boolean);
    {$ENDIF}
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

const
  MyID = 1234;   //unique id constant, just any number

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
var Wnd: hWnd;
begin
  Wnd := FindWindow('Notepad',NIL); //locate Notepad window
  if (Wnd = 0) then
    ShowMessage('Notepad window not found!')
  else
    AppendMenu(GetSubMenu(GetMenu(Wnd),1), //menu handle of notepad
               MF_STRING,    //Just by string
               MyID,         //unique menu ID
               'My Item!');  //Item to add


end;

procedure TForm1.Button2Click(Sender: TObject);
var pi: TProcessInformation;
    si: TStartupInfo;
begin
  FillMemory(@si, sizeof(si), 0);
  si.cb := sizeof(si);
  CreateProcess(nil, 'notepad', nil, nil, False, NORMAL_PRIORITY_CLASS, nil, nil, si, pi);
  WaitForInputIdle(pi.hProcess, INFINITE);
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);
end;

procedure TForm1.SSClick(Sender: TObject);
var Wnd: hWnd;
begin
  with Subc1 do begin
    Wnd := FindWindow('Notepad',NIL); //locate Notepad window
    if (Wnd = 0) then
      ShowMessage('Notepad window not found!')
    else
    begin
      WindowHandle := Wnd;
      start := NOT(start);           //start or stop the subclass
      if (start) then begin
        before.enabled := false;
        after.enabled := false;
        ss.caption := 'Stop!';
      end
      else
      begin
        before.enabled := true;
        after.enabled := true;
        ss.caption := 'Start!';
      end;
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  MsgLB.clear;
end;

procedure TForm1.ChooseClick(Sender: TObject);
begin
  ss.enabled := true;
  case choose.itemindex of
    0: Messagebox(handle,'Click Start if it''s not already!'#10'Try to click on a menu item of notepad.  If rmBeforeDefProc is checked, '+
                'then the menu click will never get passed.','Note',mb_taskmodal);
    1: Messagebox(handle,'Click Start if it''s not already!'#10'Click on any menu item of notepad.  If rmBeforeDefProc is checked, '+
                'any item you click will cause the File|Open item to be clicked because we '+
                'change the value of the wParam to the File|Open menu id.','Note',mb_taskmodal);
    2: Messagebox(handle,'Click Start if it''s not already!'#10'Click on the Append Menu button.  Look under the Edit| sub menu.  It added a new item.'+
                ' Now try clicking on that item, it will note to you that your item is clicked.','Note',mb_taskmodal);
    3:
      begin
        Messagebox(handle,'Click Start if it''s not already!'#10'Watch the listbox trace the messages.',
                   'Note',mb_taskmodal);
        Form1.Clientheight := 305;
        MsgLB.clear;
      end
  else
    Form1.clientheight := 145;
  end;
end;

procedure TForm1.beforeClick(Sender: TObject);
begin
  Subc1.ReceiveMessages := rmBeforeDefProc;
end;

procedure TForm1.afterClick(Sender: TObject);
begin
  Subc1.ReceiveMessages := rmAfterDefProc;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Subc1.start := FALSE;    //Be sure to stop the subclass when your application terminates!
                           //Always a good idea
end;

{$IFDEF VER100}    //if D3
procedure TForm1.Subc1MsgReceived(const Wnd: Integer; var Msg: Cardinal;
  var wParam, lParam: Integer; const ProcessId: Integer; rmFlag: TWhen;
  var return: Integer; var CallDefWndproc: Boolean);
{$ENDIF}
{$IFDEF VER90}   //if D2
procedure TForm1.Subc1MsgReceived(const Wnd: Integer; var Msg: Cardinal;
  var wParam, lParam: Longint; const ProcessId: Integer; rmFlag: TWhen;
  var return: Longint; var CallDefWndproc: Boolean);
{$ENDIF}
{$IFDEF VER120}   //if D4
procedure TForm1.Subc1MsgReceived(const Wnd: HWND; var Msg: Cardinal;
   var wParam, lParam: Integer; const ProcessId: Cardinal; rmFlag: TWhen;
   var return: Integer; var CallDefWndproc: Boolean);
{$ENDIF}
var menu,
    sub_menu,
    item_id: integer;
    MsgStr: string;
    txt: array[0..50] of char;
begin
  case choose.itemindex of
    0: if (msg = WM_COMMAND) and (hiword(wparam) = 0) then   //if it's a menu message
         CallDefWndProc := FALSE;                            //Indicate to NOT call default window procedure

    1: if (msg = WM_COMMAND) and (hiword(wParam) = 0) then begin    //if it's a menu message
         menu := GetMenu(Wnd);                                      //Get menu handle of window
         sub_menu := GetSubMenu(menu, 0);                           //get handle of the File sub menu
         item_id := GetMenuItemId(sub_menu, 1);                     //get handle of the File|Open ID
         wParam := item_id;                                         //change wParam to Open ID
       end;

    2: //if it's a menu message and wParam is YOUR menu ID
       if (msg = WM_COMMAND) and (hiword(wParam) = 0) and (loword(wparam) = MyID) then begin
         StrPCopy(txt,'Just clicked your menu item id!!!');
         SendMessage(FindWindowEx(Subc1.WindowHandle,0,'Edit',nil), EM_REPLACESEL, 0, LongInt(@txt[0]));
       end;

    3: begin
         MsgStr := Subc1.MsgToStr(msg);                       //Using the MsgToStr method
         if MsgStr = 'Unknown' then                           //if it's an unknown message, then
           MsgStr := 'WM_USER + ' + inttohex(msg-WM_USER,4);  //get it's hex value and add it
         MsgLB.items.add(MsgStr);
         MsgLB.perform(LB_SETTOPINDEX, MsgLB.items.count-1, 0);
       end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Subc1.OnMsgReceived := Subc1MsgReceived;
end;

end.
